--- asterisk-1.6.2.2.orig/channels/chan_iax2.c	2010-02-24 14:04:13.000000000 -0500
+++ asterisk-1.6.2.2/channels/chan_iax2.c	2010-02-24 15:22:09.000000000 -0500
@@ -7963,9 +7963,13 @@
 	memcpy(&pvt->transfer, &new, sizeof(pvt->transfer));
 	inet_aton(newip, &pvt->transfer.sin_addr);
 	pvt->transfer.sin_family = AF_INET;
-	pvt->transferring = TRANSFER_BEGIN;
 	pvt->transferid = ies->transferid;
-	store_by_transfercallno(pvt);
+	/* only store by transfercallno if this is a new transfer,
+	 * just in case we get a duplicate TXREQ */
+	if (pvt->transferring == TRANSFER_NONE)
+		store_by_transfercallno(pvt);
+	pvt->transferring = TRANSFER_BEGIN;
+
 	if (ies->transferid)
 		iax_ie_append_int(&ied, IAX_IE_TRANSFERID, ies->transferid);
 	send_command_transfer(pvt, AST_FRAME_IAX, IAX_COMMAND_TXCNT, 0, ied.buf, ied.pos);
@@ -8059,7 +8065,7 @@
 	pvt->voiceformat = 0;
 	pvt->svideoformat = -1;
 	pvt->videoformat = 0;
-	pvt->transfercallno = -1;
+	pvt->transfercallno = 0;
 	memset(&pvt->rxcore, 0, sizeof(pvt->rxcore));
 	memset(&pvt->offset, 0, sizeof(pvt->offset));
 	/* reset jitterbuffer */
